﻿using CommonBehaviors.Actions;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Windows.Media;



#region Redundancy
using HK = DemoLock.Managers.Hotkeys;
using C = DemoLock.Rotation.Combat;
using U = DemoLock.Core.Unit;
#endregion

namespace DemoLock
{
    class Main : CombatRoutine
    {
        private static readonly Version version = new Version(09, 30, 2016);
        public override string Name { get { return "[DemoLock] v" + version; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        public override WoWClass Class { get { return WoWClass.Warlock; } }

        public override Composite CombatBuffBehavior { get { return new ActionRunCoroutine(ctx => C.combatBuffing()); } }
        public override Composite CombatBehavior { get { return new ActionRunCoroutine(ctx => C.rotationSelector()); } }

        public override void Initialize()
        {
            Logging.Write(Colors.Purple, "Current Version");
            Logging.Write(Colors.Purple, "-- v" + version + " --");
            Logging.Write(Colors.Purple, "-- By GreenBrad --");
            Logging.Write(Colors.Purple, "-- A Demonology Warrlock Combat Routine --");
            HK.registerHotkeys();
        }

        public override bool WantButton { get { return true; } }
        public override void OnButtonPress() { Logging.Write(Colors.Firebrick, ">> Under Construction <<"); }
        public override void ShutDown() { HK.removeHotkeys(); }

        #region [Method] - Pulse
        public override void Pulse()
        {
            if (!StyxWoW.IsInGame || !StyxWoW.IsInWorld || Me == null || !Me.IsValid || !Me.IsAlive)
                return;
            if (!Me.Combat)
                return;
            U.Cache();
            U.enemyAnnex(40f); //<~ Set this to whatever our smallest AoE spell's range is

            //Fps Ensure
            DateTime ct = new DateTime();

            if (DateTime.Now.Subtract((DateTime)ct).TotalMilliseconds >= 50)
            {
                if (StyxWoW.WoWClient.Fps <= 15)
                {
                    if (TreeRoot.TicksPerSecond > 5)
                    {
                        TreeRoot.TicksPerSecond = 5;
                        ct = DateTime.Now;
                    }
                }
                else if (TreeRoot.TicksPerSecond < 30 && DateTime.Now.Subtract((DateTime)ct).TotalMilliseconds >= 500)
                {
                    TreeRoot.TicksPerSecond += 1;
                    ct = DateTime.Now;
                }
            }
        }
        #endregion

        public override CapabilityFlags SupportedCapabilities
        {
            get { return CapabilityFlags.Aoe | CapabilityFlags.DefensiveCooldowns | CapabilityFlags.GapCloser | CapabilityFlags.OffensiveCooldowns | CapabilityFlags.SpecialAttacks; }
        }
    }
}

