﻿using Styx.Common;
using System.Windows.Media;

namespace DemoLock.Helpers
{
    class Log
    {
        public static string lastCombatMSG;
        public static void combatLog(string Message, params object[] args)
        {
            if (Message == lastCombatMSG)
                return;
            Logging.Write(Colors.LightGreen, "[Combat Log] {0}", string.Format(Message, args));
            lastCombatMSG = Message;
        }

        public static void diagnosticsLog(string Message, params object[] args)
        {
            if (Message == null)
                return;
            Logging.WriteDiagnostic(Colors.DarkRed, "[ERROR] {0}", string.Format(Message, args));
        }
    }
}
