﻿using Styx;
using Styx.Common;
using System.Windows.Forms;
using System.Windows.Media;

namespace DemoLock.Managers
{
    class Hotkeys
    {
        public static bool AoEOn { get; set; }
        public static bool cooldownsOn { get; set; }
        public static bool manualOn { get; set; }
        public static bool axeToss;
        public static bool keysRegistered { get; set; }

        public static void registerHotkeys()
        {
            if (keysRegistered)
                return;
            HotkeysManager.Register("cooldownsOn", Keys.E, ModifierKeys.Alt, ret =>
            {
                cooldownsOn = !cooldownsOn;
                StyxWoW.Overlay.AddToast((cooldownsOn ? "Cooldowns: Enabled!" : "Cooldowns: Disabled!"), 2000);
            });
            HotkeysManager.Register("ManualOn", Keys.S, ModifierKeys.Alt, ret =>
            {
                manualOn = !manualOn;
                StyxWoW.Overlay.AddToast((manualOn ? "Manual Mode: Enabled!" : "Manual Mode: Disabled!"), 2000);
            });
            

            keysRegistered = true;
            StyxWoW.Overlay.AddToast(("Hotkeys: Registered!"), 2000);
            Logging.Write(Colors.Green, "Hotkeys: Registered!");
        }

        public static void removeHotkeys()
        {
            if (!keysRegistered)
                return;
            HotkeysManager.Unregister("cooldownsOn");
            HotkeysManager.Unregister("manualOn");
            cooldownsOn = false;
            manualOn = false;
            keysRegistered = false;
            StyxWoW.Overlay.AddToast(("Hotkeys: Removed!"), 2000);
            Logging.Write(Colors.Purple, "Hotkeys: Removed!");
        }
    }
}

